/***************************************************************************
 *   Copyright (C) 2007 by Francesc Burrull i Mestres.                     *
 *   francesc.burrull@upct.es                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _W2LAN_CALLBACK_H_
#include "w2lan_callback.h"
#endif

void w2lan_callback( unsigned char *extra , const struct pcap_pkthdr *pkthdr , const unsigned char *packet )
{

  if (DEBUG) {
     printf( "DEBUG: w2lan_callback.c: entered callback function.\n");
  }

  if (DEBUG) {
     printf( "DEBUG: w2lan_callback.c: test myMAC:::::::::::::::::: [ ");
     int i;
     for (i=0; i<ETHER_ADDR_LEN-1; ++i) {
       printf("%2.2x:", myMAC[i]);
     }
     printf("%2.2x ]\n", myMAC[ETHER_ADDR_LEN-1]);
  }


// w2lan. protocol that transforms an Ethernet MANET into a LAN
// it assumes parsing done with no errors


// FBM: Beginning of debuging area /////////////////// 
   struct ether_header *eptr;
   eptr = (struct ether_header *) packet;

   u_int8_t  *macdst;
   macdst = (u_int8_t *)malloc( ETHER_ADDR_LEN*sizeof(u_int8_t) );

   u_int8_t  *macsrc;
   macsrc = (u_int8_t *)malloc( ETHER_ADDR_LEN*sizeof(u_int8_t) );

   u_int16_t mactype = 0;

   u_int8_t  *macpayload;
   macpayload = (u_int8_t *)malloc( ETH_DATA_LEN*sizeof(u_int8_t) );

   /* take the Ethernet destination address */
   memcpy( macdst , (const struct ether_addr *)&eptr->ether_dhost , ETHER_ADDR_LEN );
   /* take the Ethernet source address */
   memcpy( macsrc , (const struct ether_addr *)&eptr->ether_shost , ETHER_ADDR_LEN );
   /* take the Ethernet frame type in host format */
   mactype = ntohs( eptr->ether_type );
   /* take the Ethernet payload */
   memcpy( macpayload, packet+14 , (pkthdr->len)-14 );

   // debugging the ether header and payload
   if (DEBUG) {

      printf( "DEBUG: w2lan_callback.c: ethernet header dest:::::::: [ ");
      int i;
      for (i=0; i<ETHER_ADDR_LEN-1; ++i) {
        printf("%2.2x:", macdst[i]);
      }
      printf( "%2.2x ]\n", macdst[ETHER_ADDR_LEN-1] );

      printf("DEBUG: w2lan_callback.c: ethernet header source:::::: [ ");
      for (i=0; i<ETHER_ADDR_LEN-1; ++i) {
        printf("%2.2x:", macsrc[i]);
      }
      printf( "%2.2x ]\n", macsrc[ETHER_ADDR_LEN-1] );

      printf("DEBUG: w2lan_callback.c: ethernet header type:::::::: [ 0x%.4X ]\n" , mactype );

      printf("DEBUG: w2lan_callback.c: ethernet payload (%d bytes): [ ", (pkthdr->len)-14 );
      for (i=0; i< ( (pkthdr->len)-14 -1); ++i) {
        printf("%2.2x:", macpayload[i]);
      }
      printf( "%2.2x ]\n", macpayload[(pkthdr->len)-14 -1] );

   }
// FBM: End of debuging area ///////////////////////// 


   // packet capture descriptor
   pcap_t *pd = (pcap_t *)extra;

   if (DEBUG) {
      printf("DEBUG: w2lan_callback.c: pd  ----> %d\n", (int)pd );
      printf("DEBUG: w2lan_callback.c: extra --> %d\n", (int)extra );
   }

   if (DEBUG) {
      printf("\nDEBUG: w2lan_callback.c: %d packets captured so far...\n", count );
      printf("DEBUG: w2lan_callback.c: Grabbed packet of length %d\n", pkthdr->len);
      printf("DEBUG: w2lan_callback.c: Recieved at %s",ctime((const time_t*)&pkthdr->ts.tv_sec)); 
      //printf("DEBUG: Ethernet address length is %d\n",ETHER_HDR_LEN);
      //printf("DEBUG: Ethernet type: 0x%x\n", ntohs(eptr->ether_type));
      count++;
   }

   if (DEBUG) {
      printf("DEBUG: w2lan_callback.c: w2lan mode: %s\n", w2lanmode );
   }

   if ( mactype == ETH_P_W2LAN_ANNOUNCE ) {
      // W2LAN Announce received
      if (DEBUG) {
         printf("DEBUG: w2lan_callback.c: w2lan Announce received (ethernet type 0x%.4X)\n", ntohs(eptr->ether_type));
      }

      // activate active window for reactive mode
      activewindow = 1;
      counteractivewindow = 0;

      if (DEBUG) {
         printf("DEBUG: w2lan_callback.c: calling announce_received...\n");
      }

      announce_received( extra , pkthdr , packet );

      if (DEBUG) {
         printf("DEBUG: w2lan_callback.c: returned from announce_received.\n");
      }

   }
   else if ( mactype == ETH_P_W2LAN_REQUEST ) {
      // W2LAN Request received
      if (DEBUG) {
         printf("DEBUG: w2lan_callback.c: w2lan Request received (ethernet type 0x%.4X)\n", ntohs(eptr->ether_type));
      }

      // activate active window for reactive mode
      activewindow = 1;
      counteractivewindow = 0;

      if (DEBUG) {
         printf("DEBUG: w2lan_callback.c: calling request_received...\n");
      }

      request_received( extra , pkthdr , packet );

      if (DEBUG) {
         printf("DEBUG: w2lan_callback.c: returned from request_received.\n");
      }
   }
   else if ( mactype == ETH_P_W2LAN_DATA ) {
      // W2LAN data received
      if (DEBUG) {
         printf("DEBUG: w2lan_callback.c: w2lan Data received (ethernet type 0x%.4X)\n", ntohs(eptr->ether_type));
      }

      // activate active window for reactive mode
      activewindow = 1;
      counteractivewindow = 0;

      if (DEBUG) {
         printf("DEBUG: w2lan_callback.c: calling data_received...\n");
      }

      data_received( extra , pkthdr , packet );

      if (DEBUG) {
         printf("DEBUG: w2lan_callback.c: returned from data_received.\n");
      }
   }
   else {
      // non W2LAN frame received
      if (DEBUG) {
         printf("DEBUG: w2lan_callback.c: Non w2lan frame received (ethernet type 0x%.4X)\n", ntohs(eptr->ether_type));
      }
      if ( strcmp( w2lanmode, "reactive" ) == 0 ) {
         // Typical for clients, i.e. windows/linux in mobile PCs 
         // in reactive mode, if we are in active window and source=myMAC generate announce

         if (DEBUG) {
            printf("DEBUG: w2lan_callback.c: counteractivewindow = %d\n", counteractivewindow );
         }
         if ( counteractivewindow == MAX_NON_W2LAN_FRAMES ) {
            counteractivewindow = 0;
            activewindow = 0;
         }
         counteractivewindow = counteractivewindow + 1;
         if (DEBUG) {
            printf("DEBUG: w2lan_callback.c: activewindow = %d\n", activewindow );
            printf("DEBUG: w2lan_callback.c: memcmp( macsrc, myMAC, ETHER_ADDR_LEN ) = %d\n", memcmp( macsrc, myMAC, ETHER_ADDR_LEN ) );
            printf( "DEBUG: w2lan_callback.c: macsrc:::::::: [ ");
            int i;
            for (i=0; i<ETHER_ADDR_LEN-1; ++i) {
              printf("%2.2x:", macsrc[i]);
            }
            printf( "%2.2x ]\n", macsrc[ETHER_ADDR_LEN-1] );
            printf( "DEBUG: w2lan_callback.c: myMAC :::::::: [ ");
            for (i=0; i<ETHER_ADDR_LEN-1; ++i) {
              printf("%2.2x:", myMAC[i]);
            }
            printf( "%2.2x ]\n", myMAC[ETHER_ADDR_LEN-1] );
         }

         if ( ( activewindow == 1) && ( memcmp( macsrc, myMAC, ETHER_ADDR_LEN ) == 0 ) ) {
            if (DEBUG) {
               printf("DEBUG: w2lan_callback.c: macsrc = [ ");
               int i;
               for (i=0; i<ETHER_ADDR_LEN-1; ++i) {
                 printf("%2.2x:", macsrc[i]);
               }
               printf("%2.2x ]\n", macsrc[ETHER_ADDR_LEN-1]);
               printf("DEBUG: w2lan_callback.c:  myMAC = [ ");
               for (i=0; i<ETHER_ADDR_LEN-1; ++i) {
                 printf("%2.2x:", myMAC[i]);
               }
               printf("%2.2x ]\n", myMAC[ETHER_ADDR_LEN-1]);
            }
            generate_announce( extra , pkthdr , packet );
         }
      }
      else if ( strcmp( w2lanmode, "passive" ) == 0 ) {
         // Typical for non-gateway, helper machines, coverage expanders
         // in passive mode, do nothing ( done :-) )
      }
      else if ( strcmp( w2lanmode, "always" ) == 0 ) {
         // Typical for gateway, linux server (dhcp+nat+...)
         // in always mode, if source=myMAC generate announce
         if ( memcmp( macsrc, myMAC, ETHER_ADDR_LEN ) == 0 ) {
            if (DEBUG) {
               printf("DEBUG: w2lan_callback.c: macsrc = [ ");
               int i;
               for (i=0; i<ETHER_ADDR_LEN-1; ++i) {
                 printf("%2.2x:", macsrc[i]);
               }
               printf("%2.2x ]\n", macsrc[ETHER_ADDR_LEN-1]);
               printf("DEBUG: w2lan_callback.c:  myMAC = [ ");
               for (i=0; i<ETHER_ADDR_LEN-1; ++i) {
                 printf("%2.2x:", myMAC[i]);
               }
               printf("%2.2x ]\n", myMAC[ETHER_ADDR_LEN-1]);
            }
            generate_announce( extra , pkthdr , packet );
         }
      }
   }
   free( macdst );
   free( macsrc );
   free( macpayload );

}
